;; the number of digits in a value:
(define DIGITS 8)
;; the numbers in memory and register: 
(define MAX-VAL (expt 10 DIGITS))
;; \scheme{value? : number -> bool}
(define (value? n) (< (abs n) MAX-VAL))

;; the number of ``immediate'' digits in instruction:
(define IMMEDIATE-DIGITS 6)
;; the range of numbers stored inside of instructions:
(define MAX-IMM (expt 10 IMMEDIATE-DIGITS))
;; \scheme{immediate? : number -> bool}
(define (immediate? n) (and (number? n) (< (abs n) MAX-IMM)))

;; the number of digits in an address: 
(define DIGITS-IN-ADD 4)
;; addresses: 
(define MAX-ADD (expt 10 DIGITS-IN-ADD))
;; addresses as vector indices: 
(define MAX-ADD-INDEX (sub1 MAX-ADD))
;; \scheme{address? : number -> bool}
(define (address? n) (and (number? n) (<= 0 n MAX-ADD-INDEX)))

;; the number of registers:
(define REGISTERS 10)
;; \scheme{(<= 0 register MAX-REG-INDEX)} : index into register bank
(define MAX-REG-INDEX (sub1 REGISTERS))
;; \scheme{register? : number -> bool}
(define (register? n) (<= 0 n MAX-REG-INDEX))
