;; \scheme@dispatch-to : (vector instruction) digit -> instruction@
(define (dispatch-to InstructionTable index)
  (lambda (sign digits)
    ((vector-ref InstructionTable (vector-ref digits index)) sign digits)))

;; \scheme@SpecialInstructions : (vector instruction)@
(define SpecialInstructions
  (vector halt print nl bad bad bad bad bad bad bad))

;; \scheme@RegisterInstructions : (vector instruction)@
(define RegisterInstructions
  (vector
    (dispatch-to SpecialInstructions 2)
    (arithmetic mod/+)
    (arithmetic mod/-)
    (arithmetic mod/*)
    (arithmetic (checked-for-0 mod/div))
    (arithmetic (checked-for-0 mod/%))
    ld/x
    st/x
    jmpx
    mov))

;; \scheme@ImmediateInstructions : (vector instruction)@
(define ImmediateInstructions
  (vector
    (dispatch-to RegisterInstructions 1)
    jmpi
    jsr
    (branch-on =) 
    (branch-on not=) 
    (branch-on <)
    (branch-on <=)
    (branch-on >)
    (branch-on >=)
    ldi))
