;;
;; Jam2000 0.93 --- Last updated: September 10, 1998
;; 
;; Author: Matthias Felleisen, Eric Virro
;; Design: Cartwright, Felleisen, Lu, Virro
;
;; "l"oad command added. 01.nov -- ian
;; Various touch-ups made.  01.nov -- ian
;; teachpack'd 01.nov -- ian  (for v103, not yet v200)
;;
;; This program could be overhauled,
;; (a) more easily allow different architectures to be swapped in/out,
;;     (instruction sets themselves are currently fairly modular)
;; (b) allow a gui,
;; (c) adapt to more recent drscheme i/o, etc.
;; NB. ~comp200/Software/Jelly2000 is based on Jam2000, 
;; except with no registers --
;; all commands are immediate memory commands.
;; Jelly2000 has a multi-user (core-wars) variant, Preserves2000.
;;
;; Someday, i'll get the energy to do all this.
;; Or, maybe not.



;; See /home/comp210/public_html/Homeworks/Hw05/xexpr210.ss
;; for a description of the magic of signature, unit/sig, compound-unit/sig.
;;
(define-signature jam^ (walk))

(define jam-unit
  (unit/sig jam^
    (import plt:userspace^)

    ; Now, the implementation:

(include "global.ss")
(include "aux.ss")
(include "mem.ss")
(include "reg.ss")
(include "pc.ss")
(include "im-ins.ss")
(include "mod-ari.ss")
(include "reg-ins0.ss")
(include "reg-ins.ss")
(include "sp-ins.ss")
(include "instructions.ss")
(include "cpu.ss")
(include "bios.ss")

; Hmm, this prints in the OS shell, not inside drscheme:
;(printf "Evaluate \"(walk)\" to start the Jam machine inspector.~n")

    ))


;; At this point, jam-unit is a single unit.
;; If you ever want to use it, you must provide
;; actual implementations of the functions it imports --
;; namely those in plt:userspace^, xml^.


;; Let's roll together the unit we just made with the imports it needs.
;;
(compound-unit/sig 
  (import (p : plt:userspace^))  ; p is a formal argument.
  (link [ jam-bound-unit : jam^ (jam-unit p)  ])        
  (export (open jam-bound-unit)))





