;; \scheme{mem-array : (vector value),} initialized to \scheme{0}
(define mem-array (make-vector MAX-ADD 0))

;; \scheme{get-mem : number[address] -> value}
(define (get-mem addr)
  (if (address? addr)
      (vector-ref mem-array addr)
      (machine-error 'get-mem "invalid address: ~s" addr)))

;; \scheme{set-mem! : number[address] number[value] -> void}
(define (set-mem! addr val)
  (if (and (address? addr) (value? val))
      (vector-set! mem-array addr val)
      (machine-error 'set-mem! "invalid address/value: ~s ~s" addr val)))


