;; \scheme{mem-array : (vector value)}, initialized to \scheme{0}
(define reg-array (make-vector REGISTERS 0))

;; \scheme{get-reg : number[register] -> value}
(define (get-reg reg)
  (if (register? reg)
      (vector-ref reg-array reg)
      (machine-error 'get-reg "invalid reg number: ~s" reg)))

;; \scheme{set-reg! : number[register-index] number[value] -> void}
(define (set-reg! reg val)
  (if (and (register? reg) (value? val))
      (vector-set! reg-array reg val)
      (machine-error 'set-reg! "invalid reg number: ~s" reg)))

